"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _detectors = require("../utils/detectors");

var _transpileLess = _interopRequireDefault(require("./transpileLess"));

var _generator = _interopRequireDefault(require("@babel/generator"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var regex = /`([\s\S]*)`/;

var _default = function _default(path, state, _ref) {
  var t = _ref.types;

  if (!((0, _detectors.isStyled)(t)(path.node.tag, state) || (0, _detectors.isPureHelper)(t)(path.node.tag || path.node.callee, state))) {
    return;
  } // Find the TemplateLiteral in the TaggedTemplateExpression


  path.traverse({
    TemplateLiteral: function TemplateLiteral(p) {
      if (p.isClean) return;
      p.stop(); // Only traverse the first TemplateLiteral of TaggedTemplateExpression

      var rawSource = p.getSource();

      if (!rawSource) {
        var _generate = (0, _generator["default"])({
          type: 'Program',
          body: [path.node]
        }),
            code = _generate.code;

        rawSource = code;
      }

      var _regex$exec = regex.exec(rawSource),
          _regex$exec2 = _slicedToArray(_regex$exec, 2),
          source = _regex$exec2[1];

      if (!source) return;
      p.isClean = true;
      var cursor;
      var sq = 0;
      var dict = {};

      while ((cursor = source.indexOf('${')) > -1) {
        var start = cursor;
        cursor += 1;
        var close = void 0;
        var stack = 1;

        while (stack > 0) {
          close = source.indexOf('}', cursor + 1);
          if (close === -1) throw 'template brace not balanced';
          var open = source.indexOf('{', cursor + 1);

          if (open === -1 || open > close) {
            cursor = close;
            stack -= 1;
          } else {
            cursor = open;
            stack += 1;
          }
        }

        var tpl = source.slice(start, close + 1);
        var key = "var(--LESS-FOR-STYLED-".concat(sq++, ")");
        dict[key] = tpl;
        source = source.replace(tpl, key);
      }

      cursor = 0;
      var topLevelStyleAndSelectorEnd;

      while ((topLevelStyleAndSelectorEnd = source.indexOf('{', cursor)) > 1) {
        var topLevelStyleAndSelector = source.substring(cursor, topLevelStyleAndSelectorEnd);
        var _start = cursor;
        cursor = topLevelStyleAndSelectorEnd;

        var _close = void 0;

        var _stack = 1;

        while (_stack > 0) {
          _close = source.indexOf('}', cursor + 1);
          if (_close === -1) throw 'style brace not balanced';

          var _open = source.indexOf('{', cursor + 1);

          if (_open === -1 || _open > _close) {
            cursor = _close + 1;
            _stack -= 1;
          } else {
            cursor = _open;
            _stack += 1;
          }
        }

        var selectorIndex = topLevelStyleAndSelector.lastIndexOf(';') + 1;
        var selector = topLevelStyleAndSelector.substring(selectorIndex);

        if (selector.trim().startsWith('&')) {
          var _key = "var(--LESS-FOR-STYLED-".concat(sq++, ")");

          dict[_key] = selector;
          source = source.substring(0, _start + selectorIndex) + _key + source.substring(_start + selectorIndex + selector.length);
        }
      }

      if (Array.isArray(state.opts.globalImports)) {
        source = state.opts.globalImports.map(function (f) {
          return "@import \"".concat(f, "\";");
        }).join('') + source;
      }

      try {
        var raw = (0, _transpileLess["default"])(source, state.file.opts.filename, state.opts);
        Object.keys(dict).forEach(function (k) {
          return raw = raw.replaceAll(k, dict[k]);
        });

        if (source !== raw) {
          p.replaceWithSourceString('`' + raw + '`');
        }
      } catch (e) {
        console.error("Error converting the less syntax for the file:", state.file.opts.filename, rawSource, e);
      }
    }
  });
};

exports["default"] = _default;